;
; $Id: main.scm,v 1.10 2003/01/19 08:14:32 jp Exp $
;
; The "main" code that starts the gui.  Instantiates a lissom console
; with the path to the lissom directory or executable file.
;

(require  gui
	 (lib "class.ss" "mzlib")
	 (lib "mred.ss" "mred"))

;
; make the gui run in a new thread and eventspace
;
(current-eventspace (make-eventspace))


; load extensions
; (load-all-extensions)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; start the gui

(define *lissom-path* 
  (let ((args (current-command-line-arguments)))
    ;(printf "args: ~A~%" (vector-length args))
    (cond ((< 0 (vector-length args))
	   (vector-ref args 0))
	  (else
	   (get-simulation-dir #f)))))

(define console #f)
  
(queue-callback
 ;
 ; This makes sure the console initialization
 ; occurs in the same thread that handles console events.
 ;
 (lambda ()
   (set! console (instantiate lissom-console% () 
                   (lissom-path *lissom-path*)))
   (send console show #t)))

