/** \file
  PointerLookup class.

  $Header: /u/nn/cvsroot/lissom/src/pointerlookup.h,v 1.2 2001/04/01 07:05:59 jbednar Exp $
*/

#ifndef __POINTERLOOKUP_H__
#define __POINTERLOOKUP_H__

#include <string>
using std::string;


/** Abstract, lookup-only base class for a PointerMap, i.e.
    a map from strings (or other keys) to a pointer
*/
template<class T, class K=string>
class PointerLookup {
public:
  /** Key type of our local map. */
  typedef K  key_type;

  /** Data element type of our local map. */
  typedef T* data_type;

  virtual ~PointerLookup() { }

  /** Similar to map's [], but if the key is not present just returns a
      null pointer without adding a new entry. */
  virtual T* getptr(const key_type& k)=0;
  
  /** Const version of getptr */
  virtual const T* getptr(const key_type& k) const=0;
};


#endif /* __POINTERLOOKUP_H__ */
