/** \file
  ValueGenContainer class.

  $Header: /u/nn/cvsroot/lissom/src/valuegencontainer.h,v 1.1 2001/03/18 21:23:28 jbednar Exp $
*/

#ifndef __VALUEGENCONTAINER_H__
#define __VALUEGENCONTAINER_H__

#include <vector>
#include <algorithm>
#include <functional>

#include "vgen.h"
#include "genericalgs.h"


/** Generic bag of ValueGens */
class ValueGenContainer : public ValueGen {
public:
  virtual ~ValueGenContainer() {  Generic::delete_contents(c);  }

  virtual void reset()
    {  std::for_each(c.begin(),c.end(),std::mem_fun(&ValueGen::reset));  }

  virtual bool next()
    {  return std::count_if(c.begin(),c.end(),std::mem_fun(&ValueGen::next));  }

  /** The given ValueGen must have been allocated using new;
     the container is responsible for eventually deleting it. */
  virtual void push_back(ValueGen* v) {  c.push_back(v);  }
  
protected:
  /** The underlying container. */
  std::vector< ValueGen* > c;
};


#endif /* __VALUEGENCONTAINER_H__ */
