/** \file
  ValueGen class.
  $Header: /u/nn/cvsroot/lissom/src/vgen.h,v 1.6 2001/04/04 02:36:57 jbednar Exp $
*/

#ifndef __VGEN_H__
#define __VGEN_H__

/**
  Abstract base class for anything that supports a next and a reset.
  Such an object is either stateless or has state that can be accessed
  in discrete time steps.  This class is generally used as a base type
  for a variety of otherwise unrelated classes that all need to be
  advanced to the next iteration at the same time, and that can all be
  reset to their starting state.
*/
class ValueGen {
public:
  ValueGen() { };
  virtual ~ValueGen() { }
  /** Advance to the next state (whatever that means for this object). */
  virtual bool next()=0;
  /** Reset to the starting state. */  
  virtual void reset()=0;
};

#endif /* __VGEN_H__ */
