/* -*-mode: C++; compile-command: "gmake -C../tests colorlookup.test"; -*- */
/**
  \file   Tests the corresponding .h file.
  $Header: /u/nn/cvsroot/lissom/tests/colorlookup.c,v 1.15 2001/11/24 23:27:39 jbednar Exp $
*/

#include "testutils.h"
#include "pixelutils.h"
#include "../src/colorlookup.h"

int main(int, char**)
{
  section("Sizes");
#ifdef _CRAYMPP
  EXACT_CHECK( int(sizeof(Plot::ColorLookup<>)),      32);
  EXACT_CHECK( int(sizeof(Plot::ColorLookupTable<>)), 56);
  EXACT_CHECK( int(sizeof(Plot::RYWColorLookup<>)),   56);
#elif (__GNUC__ && (__GNUC__ >= 3))
  EXACT_CHECK( int(sizeof(Plot::ColorLookup<Plot::RGBPixel<>,Scale::Linear<double> >)),      20);
  EXACT_CHECK( int(sizeof(Plot::ColorLookupTable<>)), 36);
  EXACT_CHECK( int(sizeof(Plot::RYWColorLookup<>)),   36);
#else
  EXACT_CHECK( int(sizeof(Plot::ColorLookup<Plot::RGBPixel<>,Scale::Linear<double> >)),      24);
  EXACT_CHECK( int(sizeof(Plot::ColorLookupTable<>)), 40);
  EXACT_CHECK( int(sizeof(Plot::RYWColorLookup<>)),   40);
#endif
  
  section("Construction");
  typedef Plot::RYWColorLookup<Plot::RGBPixel<>,Scale::Linear<double> > RYWLookup;
  RYWLookup t;

  section("Values");
  Plot::RGBPixel<> undersaturated(t(-0.1));  RGB_MATCH(undersaturated,0.0,0.0,0.0);
  Plot::RGBPixel<> black(t(0.0));            RGB_MATCH(black,0.0,0.0,0.0);
  Plot::RGBPixel<> orange(t(0.5));           RGB_MATCH(orange,1.0,0.48,0.0);
  Plot::RGBPixel<> white(t(1.0));            RGB_MATCH(white,1.0,1.0,1.0);
  Plot::RGBPixel<> oversaturated(t(2.0));    RGB_MATCH(oversaturated,1.0,1.0,1.0);
#ifndef ERRORS_ONLY  
  std::cout << "It is not clear whether the 0.984314 values for white's blue() are a problem." << std::endl;
#endif
  
  return count_errors();
}
